/* $Id: socklist.h,v 1.1.2.1 2001/05/01 17:47:45 dps Exp $ */

#ifndef __LINUX_SOCKLIST_H__
#define __LINUX_SOCKLIST_H__ 1

#define UNKNOWN_DEVICE ((dev_t) -1)
#define UNKNOWN_INODE ((ino_t) -1)
#define UNKNOWN_UID ((uid_t) -1)

/* A refrence to a socket */
typedef struct __sock_ref
{
    pid_t pid;			/* Process id */
    int fd;			/* File descriptor */
    struct __sock_ref *next;	/* Next */
}  sockref;

typedef struct __sock_list
{
    int matchval;		/* for ,matching alggorithm */
    sa_family_t fam;		/* Family */
    enum __socket_type type;	/* Socket type */
    struct sockaddr *src;	/* Source */
    struct sockaddr *dest;	/* Destination */
    dev_t dev;			/* Device (obscure) */
    ino_t inode;		/* Inode (inode, testable) */
    uid_t uid;			/* Uid (testable?)  */
    sockref *refs;		/* Refrences to socket */
    struct __sock_list *next;
} socklist;

/* socklst.c */
extern void socklist_zap(socklist *l);
extern void free_sock(struct __sock_list *sp);
extern void socklist_append(socklist **s1, socklist *s2);

/* sockmatch.c */
extern void socklist_setval(socklist *scan, int v);
extern socklist *socklist_aggregate(socklist *s1, socklist *s2);

/* sockprint.c */
extern void print_socklist(const socklist *l);

#endif /* __LINUX_SOCKLIST_H__ */
