/* $Id: string.c,v 1.2 2000/10/10 22:10:44 dps Exp $ */
/* Read string followed by white space */

#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif /* HAVE_CONFIG_H */
#ifdef HAVE_STDIO_H
#include <stdio.h>
#endif /* HAVE_STDIO_H */
#ifdef HAVE_CTYPE_H
#include <ctype.h>
#endif /* HAVE_CTYPE_H */

int get_string(FILE *in, char *space, int bufsiz)
{
    int c, n;

    n=0;
    while (--bufsiz>0 && (c=fgetc(in))!=EOF)
    {
	if (isspace(c))
	{
	    ungetc(c, in);	/* Push back c */
	    *space='\0';	/* Terminate the string */
	    return n;
	}
	n++;
	*(space++)=c;
    }
    *space='\0';		/* Terminate the string */
    if (bufsiz==0)
	return -1;		/* Signal nasty problem */
    return n;
}

int skip_string(FILE *in, int size)
{
    int c, n;

    n=0;
    while (--size>0 && (c=fgetc(in))!=EOF)
    {
	if (isspace(c))
	{
	    ungetc(c, in);
	    return n;
	}
	n++;
    }
    if (size==0)
	return -1;		/* Signal failure */
    return n;
}

int require_string(FILE *in, const char *s)
{
    int c;

    while(*s!='\0')
    {
	if ((c=fgetc(in))!=*s)
	    return 0;
	s++;
    }
    return 1;
}
