/* $Id: numbuf.c,v 1.1.1.1 2000/05/04 22:56:04 dps Exp $ */
#include "config.h"
#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#endif /* HAVE_STDLIB_H */
#ifdef HAVE_STDDEF_H
#include <stddef.h>
#endif /* HAVE_STDDEF_H */
#define ___CPS__NUMBUF_CONFIG 1
#include "numbuf.h"

/* Expandable number buffer support */
int expand_buf(numbuf *n)
{
    int nn,i,*newbuf;

    if (n->max>=MAXX_NUMS)
	return 0;
    nn=n->max+INC;
    if ((newbuf=(int *)malloc(sizeof(int)*nn))==NULL)
	return 0;

    for (i=0; i<n->max; i++)
	newbuf[i]=n->nums[i];
    free(n->nums);
    n->nums=newbuf;
    n->max=nn;
    return 1;
}

numbuf *allocate(void)
{
    int *np;
    numbuf *r;

    if ((np=(int *) malloc(sizeof(int)*INITIAL_NUMS))==NULL)
	return NULL;
    if ((r=(numbuf *) malloc(sizeof(numbuf)))==NULL)
    {
	free(np);
	return NULL;
    }
    r->nums=np;
    r->max=INITIAL_NUMS;
    r->pos=0;
    return r;
}

void empty_nums(numbuf *n)
{
    n->pos=0;
}

void free_nums(numbuf *n)
{
    if (n->nums!=NULL)
	free(n->nums);
    free(n);
}
